From 1382ebc5575a53b6f7654dc84541824a36023ed6 Mon Sep 17 00:00:00 2001
From: =?utf-8?q?Rafa=C5=82=20Mi=C5=82ecki?= <zajec5@gmail.com>
Date: Sat, 6 Jun 2009 21:09:33 +0200
Subject: [PATCH] PLL: RV620 PLL shutdowning fix (follow AtomBIOS method)

Fixes bug #18016
---
 src/rhd_pll.c |   10 ++++++++--
 1 files changed, 8 insertions(+), 2 deletions(-)

diff --git a/src/rhd_pll.c b/src/rhd_pll.c
index 45ab03a..981ab54 100644
--- a/src/rhd_pll.c
+++ b/src/rhd_pll.c
@@ -732,9 +732,12 @@ RV620PLL1Power(struct rhdPLL *PLL, int Power)
 	RHDRegMask(PLL, P1PLL_CNTL, 0x01, 0x01); /* Reset */
 	usleep(2);
 
-	RHDRegMask(PLL, P1PLL_CNTL, 0x02, 0x02); /* Power down */
+	if ((RHDRegRead(PLL, RV620_EXT1_DIFF_POST_DIV_CNTL) & 0x0100) == 0)
+	    RHDRegMask(PLL, P1PLL_CNTL, 0x02, 0x02);
 	usleep(200);
 
+	RHDRegMask(PLL, P1PLL_CNTL, 0x2000, 0x2000);
+
 	return;
     }
 }
@@ -781,9 +784,12 @@ RV620PLL2Power(struct rhdPLL *PLL, int Power)
 	RHDRegMask(PLL, P2PLL_CNTL, 0x01, 0x01); /* Reset */
 	usleep(2);
 
-	RHDRegMask(PLL, P2PLL_CNTL, 0x02, 0x02); /* Power down */
+	if ((RHDRegRead(PLL, RV620_EXT2_DIFF_POST_DIV_CNTL) & 0x0100) == 0)
+	    RHDRegMask(PLL, P2PLL_CNTL, 0x02, 0x02);
 	usleep(200);
 
+	RHDRegMask(PLL, P2PLL_CNTL, 0x2000, 0x2000);
+
 	return;
     }
 }
-- 
1.6.0.2

